//SQ7613_I2C0_Master_EEPROM_24C08

//*************************************************************************************
// 	: main.c
// 汾		: V1.3 (Sep. 4, 20)
// 		: 
// ˵	: 24C08 R/W 
//			  IDE趨ϵ㣬ͨѶͬд뼰ȡEEPROM_24C08֮
// ע		: 
//			  1. (P0.5)SDA0----ӵ----24C08 SDA Pin
//				 (P0.6)SCL0----ӵ----24C08 SCL Pin
//	             *[ע]SDA,SCLⲿ
//            2.
//				 [LED] LED 1  (P2.0)
//				 [LED] LED 2  (P2.1)
//				 [LED] LED 3  (P2.2)
//
//            3. Write Sequence ʱLED1~3õ(ܹ۲쵽LEDƻһ)
//**************************************************************************************
#ifndef	IO_MEM
#define	IO_MEM
#endif
#include "main.h"

/* ----------------------  -------------------------- */
unsigned char      iloop;
unsigned char      wBuf[16];  // ʹдSlave֮
unsigned char      rBuf[16];  // ôSlaveնȡ֮

// Ϊ˷չʾ鿴д16 0xFFEEPROM
unsigned char      wBufFF[] = {0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF,
							     0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF, 0xFF};

/* -----------------------  --------------------------- */
void main()
{
  /* ---------------------- ϵͳʼ ------------------------ */
	PLLCR0_PLLEN  = 1;                     	  //  PLL
	while(PLLCR0_PLLRDY ==0);				  // ȴ PLL 
	CLKCR0_SCKPSC = 1;                        // ϵͳƵʳ2   (48M/2=24MHz) 
    CLKCR0_SCKSRC = 1;                        // ʱԴлPLL
	while(CLKCR0_SCKRDY ==0);				  // ȴ ϵͳʱ 
    
	Delay_Loop_Init();                        // ʱȦʼ
                                              // (ʹSQ7613_Delay_Loop.cʱȦ)
  
  /* ---------------------- ܽųʼ ------------------------ */
    P2OE  = 0x17;                             // 趨P2.0,P2.1,P2.2 ܽΪ
    // P3OE  = 0xF1;                          // 趨P3.1,P3.2,P3.3 ܽΪ
	// P3PU |= 0x0E;                       	  // 趨P3.1,P3.2,P3.3 

	LED1_to_LED3_turn_off;                    // ʼ趨LED1~3Ϊ״̬

  /* ---------------------------------------------------------- */
	// 趨16ʵ write buffer data
    for( iloop=0; iloop<16; iloop++ ){
        wBuf[iloop]  = 0x10+iloop;
	}
  /* ---------------------- I2C0ܳʼ ------------------------ */ 
    I2C0_Init();						      // I2C0, 8λֽ , Ack , ģʽ							
    
  //----------------------------------------------------------------

  // * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //
  //  Master Operation                                                         //
  // * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //

    // Write Sequence FF
    // Ϊ˷չʾ鿴д16 0xFFEEPROM
    
        LED1_to_LED3_turn_on;                      // 趨LED1~3Ϊ
        delay_ms(100);
        
        I2C0_Start(0xa0, 0x00);			           // Ϊģʽʼʹ1ֽ(1byte)(0x00)  
        //..........| 0xa0: 趨 slave Device ID (AT24C08 EEPROM)
        //................| 0x00: 趨 slave start address

        // Slave֮0x00λÿʼд16ݣд֮ΪwBufFF[]
        I2C0_Bytes_Write(wBufFF, 16); 	
        I2C0_Stop();                               // ֹͣ
        					           
        delay_ms(6);                               // ȴ AT24C08A pgm time >5ms...
  
        LED1_to_LED3_turn_off;                     // 趨LED1~3Ϊ
        __asm("NOP");					           // ָ,IDE趨ϵ㴦

	//-------------------------------------------------------------------------------------
	// Read Sequence
    //  0x00ʼһвŵrBuf

        I2C0_Start(0xa0, 0x00);			            // Ϊģʽʼʹ1ֽ(1byte)(0x00)  
        //..........| 0xa0: 趨 slave Device ID (AT24C08 EEPROM)
        //................| 0x00: 趨 slave start address
        I2C0_ReStart(0xa0);          	            // ظʼ
        
        // Slave֮0x00λÿʼ16ݣȡյݷŵrBuf[]
        I2C0_Bytes_Read(rBuf, 16);
        I2C0_Stop();					            // ֹͣ
        
        __asm("NOP");					            // ָ
        __asm("NOP");
        __asm("NOP");
        __asm("NOP");
        __asm("NOP");					            // ָ,IDE趨ϵ㴦
	
	//-------------------------------------------------------------------------------------
    // Write Sequence
    //  0x00ʼдһwBuf
    
        LED1_to_LED3_turn_on;                       // 趨LED1~3Ϊ    
        delay_ms(100);

        I2C0_Start(0xa0, 0x00);			            // Ϊģʽʼʹ1ֽ(1byte)(0x00)  
        //..........| 0xa0: 趨 slave Device ID (AT24C08 EEPROM)
        //................| 0x00: 趨 slave start address

        // Slave֮0x00λÿʼд3ݣд֮ΪwBuf[]
        I2C0_Bytes_Write(wBuf, 3);
        I2C0_Stop();					            // ֹͣ

        delay_ms(6);                                // ȴ AT24C08A pgm time >5ms...
    
        LED1_to_LED3_turn_off;                      // 趨LED1~3Ϊ 
        __asm("NOP");					            // ָ,IDE趨ϵ㴦

	//-------------------------------------------------------------------------------------
    // Read Sequence
    // 0x00ʼһвŵrBuf
    
        I2C0_Start(0xa0, 0x00);			            // Ϊģʽʼʹ1ֽ(1byte)(0x00)  
        //..........| 0xa0: 趨 slave Device ID (AT24C08 EEPROM)
        //................| 0x00: 趨 slave start address
        I2C0_ReStart(0xa0);          	            // ظʼ

        // Slave֮0x00λÿʼ10ݣȡյݷŵrBuf[]
        I2C0_Bytes_Read(rBuf, 10);
        I2C0_Stop();					            // ֹͣ
        
        __asm("NOP");					            // ָ
        __asm("NOP");
        __asm("NOP");
        __asm("NOP");
        __asm("NOP");					            // ָ,IDE趨ϵ㴦

	//-------------------------------------------------------------------------------------
    // Write Sequence
    // 0x06ʼдһwBuf

        LED1_to_LED3_turn_on;                       // 趨LED1~3Ϊ
        delay_ms(100);

        I2C0_Start(0xa0, 0x06);			            // Ϊģʽʼʹ1ֽ(1byte)(0x06)  
        //..........| 0xa0: 趨 slave Device ID (AT24C08 EEPROM)
        //................| 0x06: 趨 slave start address

        // Slave֮0x06λÿʼд2ݣд֮ΪwBuf[]
        I2C0_Bytes_Write(wBuf, 2);
        I2C0_Stop();					            // ֹͣ
        
        delay_ms(6);                                // ȴ AT24C08A pgm time >5ms...
        
        LED1_to_LED3_turn_off;                      // 趨LED1~3Ϊ
        __asm("NOP");					            // ָ,IDE趨ϵ㴦

	//-------------------------------------------------------------------------------------
    // Read Sequence
    // 0x00ʼһвŵrBuf
    
        I2C0_Start(0xa0, 0x00);			            // Ϊģʽʼʹ1ֽ(1byte)(0x00)  
        //..........| 0xa0: 趨 slave Device ID (AT24C08 EEPROM)
        //................| 0x00: 趨 slave start address
        I2C0_ReStart(0xa0);          	            // ظʼ
        
        // Slave֮0x00λÿʼ10ݣȡյݷŵrBuf[]
        I2C0_Bytes_Read(rBuf, 10);
        I2C0_Stop();					            // ֹͣ
        __asm("NOP");					            // ָ,IDE趨ϵ㴦

	//-------------------------------------------------------------------------------------
    // Read Sequence
    // 0x05ʼһвŵrBuf

        I2C0_Start(0xa0, 0x05);			            // Ϊģʽʼʹ1ֽ(1byte)(0x05)  
        //..........| 0xa0: 趨 slave Device ID (AT24C08 EEPROM)
        //................| 0x05: 趨 slave start address
        I2C0_ReStart(0xa0);          	            // ظʼ
        
        // Slave֮0x05λÿʼ10ݣȡյݷŵrBuf[]
        I2C0_Bytes_Read(rBuf, 10);
        I2C0_Stop();					            // ֹͣ
        __asm("NOP");					            // ָ,IDE趨ϵ㴦

	//-------------------------------------------------------------------------------------

    while(1){
        CLR_WDT;						      // Źʱ (ι)
    }



}



/* ---------------------- жϷ ------------------------ */
void __interrupt OnlyReti(void)
{
	__asm("NOP"); 							  // ָ
}

void __interrupt_n OnlyRetn(void)
{
	__asm("NOP");							  // ָ
}

void __interrupt_n IntWDT(void)
{
	__asm("NOP");							  // ָ
}

void __interrupt_n IntSWI(void)              // SWIλжϷ
{
	PRSTR7 = 0x5a;
	PRSTR7 = 0xa5;
	PRSTR7 = 0xc3;
	PRSTR7 = 0x3c;	
}
/* -------------------  жϷ ---------------------- */


/* -------------------- SQ7613ж ------------------ */
#pragma section const INT_VECTOR1 0xff40
void * const IntTbl1[] = {											
	OnlyReti,				/* 0xff40 : Reserved		*/									
	OnlyReti,				/* 0xff42 : Reserved		*/									
	OnlyReti,				/* 0xff44 : Reserved		*/									
	OnlyReti,				/* 0xff46 : Reserved		*/								
	OnlyReti,				/* 0xff48 : Reserved		*/									
	OnlyReti,				/* 0xff4a : Reserved		*/									
	OnlyReti,				/* 0xff4c : Reserved		*/									
	OnlyReti,				/* 0xff4e : Reserved		*/									
	OnlyReti,				/* 0xff50 : Reserved		*/									
	OnlyReti,				/* 0xff52 : Reserved		*/									
	OnlyReti,				/* 0xff54 : Reserved		*/									
	OnlyReti,				/* 0xff56 : Reserved		*/									
	OnlyReti,				/* 0xff58 : IntTCA7			*/	//жԴ:TCA7 16λʱ								
	OnlyReti,				/* 0xff5a : IntTCA6			*/	//жԴ:TCA6 16λʱ							
	OnlyReti,				/* 0xff5c : Reserved		*/									
	OnlyReti,				/* 0xff5e : Reserved		*/									
	OnlyReti,				/* 0xff60 : Reserved		*/									
	OnlyReti,				/* 0xff62 : Reserved		*/									
	OnlyReti,				/* 0xff64 : Reserved		*/									
	OnlyReti,				/* 0xff66 : Reserved		*/									
	OnlyReti,				/* 0xff68 : Reserved		*/									
	OnlyReti,				/* 0xff6a : Reserved		*/									
	OnlyReti,				/* 0xff6c : IntTX2			*/	//жԴ:UART2 TX2								
	OnlyReti,				/* 0xff6e : IntRX2			*/	//жԴ:UART2 RX2							
	OnlyReti,				/* 0xff70 : Reserved		*/									
	OnlyReti,				/* 0xff72 : Reserved		*/									
	OnlyReti,				/* 0xff74 : Reserved		*/									
	OnlyReti,				/* 0xff76 : IntTCA5			*/	//жԴ:TCA5 16λʱ								
	OnlyReti,				/* 0xff78 : IntTCA4			*/	//жԴ:TCA4 16λʱ								
	OnlyReti,				/* 0xff7a : Reserved		*/									
	OnlyReti,				/* 0xff7c : Reserved		*/									
	OnlyReti,				/* 0xff7e : Reserved		*/									
	OnlyReti,				/* 0xff80 : Reserved		*/									
	OnlyReti,		    	/* 0xff82 : Reserved		*/									
	OnlyReti,	    		/* 0xff84 : Reserved		*/									
	OnlyReti,				/* 0xff86 : Reserved		*/									
	OnlyReti,				/* 0xff88 : Reserved		*/									
	OnlyReti,				/* 0xff8a : Reserved		*/									
	OnlyReti,				/* 0xff8c : IntSIO1			*/	//жԴ:SIO 1								
	OnlyReti,				/* 0xff8e : IntI2C1			*/	//жԴ:I2C 1						
	OnlyReti,				/* 0xff90 : IntTX1			*/	//жԴ:UART1 TX1							
	OnlyReti,				/* 0xff92 : IntRX1			*/	//жԴ:UART1 RX1								
	OnlyReti,				/* 0xff94 : Reserved		*/									
	OnlyReti,				/* 0xff96 : Reserved		*/									
	OnlyReti,				/* 0xff98 : Reserved		*/									
	OnlyReti,				/* 0xff9a : IntTCA3			*/	//жԴ:TCA3 16λʱ							
	OnlyReti,				/* 0xff9c : IntTCA2			*/	//жԴ:TCA2 16λʱ								
	OnlyReti,				/* 0xff9e : Reserved		*/									
	OnlyReti,				/* 0xffa0 : IntMAC			*/	//жԴ:˷								
	OnlyReti,				/* 0xffa2 : IntEXT7			*/	//ⲿж7								
	OnlyReti,				/* 0xffa4 : IntEXT6			*/	//ⲿж6								
	OnlyReti,				/* 0xffa6 : IntEXT5			*/	//ⲿж5								
	OnlyReti,				/* 0xffa8 : IntEXT4			*/	//ⲿж4								
	OnlyReti,				/* 0xffaa : Reserved		*/									
	OnlyReti,				/* 0xffac : Reserved		*/									
	OnlyReti,				/* 0xffae : Reserved		*/							
	OnlyReti,				/* 0xffb0 : IntDIC			*/	//жԴ:DIC								
	OnlyReti,				/* 0xffb2 : Reserved		*/							
	OnlyReti,				/* 0xffb4 : Reserved		*/									
	OnlyReti,				/* 0xffb6 : Reserved		*/									
	OnlyReti,				/* 0xffb8 : Reserved		*/									
	OnlyReti,				/* 0xffba : Reserved		*/									
	OnlyReti,				/* 0xffbc : Reserved		*/									
	OnlyReti,				/* 0xffbe : Reserved		*/									
	OnlyReti,				/* 0xffc0 : Reserved		*/									
	OnlyReti,				/* 0xffc2 : Reserved		*/									
	OnlyReti,				/* 0xffc4 : IntFMC			*/	//жԴ:Flash								
	OnlyReti,				/* 0xffc6 : Reserved		*/					
	OnlyReti,				/* 0xffc8 : Reserved		*/									
	OnlyReti,				/* 0xffca : Reserved		*/									
	OnlyReti,				/* 0xffcc : Reserved		*/									
	OnlyReti,               /* 0xffce : IntADC			*/	//жԴ:ADC								
	OnlyReti,				/* 0xffd0 : IntEXT3			*/	//ⲿж3								
	OnlyReti,				/* 0xffd2 : IntEXT2			*/	//ⲿж2								
	OnlyReti,				/* 0xffd4 : IntEXT1			*/	//ⲿж1								
	OnlyReti,				/* 0xffd6 : IntEXT0			*/	//ⲿж0								
	OnlyReti,				/* 0xffd8 : IntSIO0			*/	//жԴ:SIO 0								
	OnlyReti,				/* 0xffda : IntI2C0			*/	//жԴ:I2C 0								
	OnlyReti,				/* 0xffdc : IntTX0			*/	//жԴ:UART0 TX0								
	OnlyReti,				/* 0xffde : IntRX0			*/	//жԴ:UART0 RX0								
	OnlyReti,				/* 0xffe0 : Reserved		*/									
	OnlyReti,				/* 0xffe2 : Reserved		*/									
	OnlyReti,				/* 0xffe4 : Reserved		*/									
	OnlyReti,				/* 0xffe6 : IntTCA1			*/	//жԴ:TCA1 16λʱ								
	OnlyReti,				/* 0xffe8 : IntTCA0			*/	//жԴ:TCA0 16λʱ								
	OnlyReti,				/* 0xffea : Reserved		*/									
	OnlyReti,				/* 0xffec : Reserved		*/									
	OnlyReti,			    /* 0xffee : Reserved		*/						
	OnlyReti,				/* 0xfff0 : IntTBT			*/  //жԴ:ʱTBTʱ				
	OnlyReti,				/* 0xfff2 : Reserved		*/									
	OnlyReti,				/* 0xfff4 : IntCFD			*/	//жԴ:ʱʧЧ								
	OnlyReti,				/* 0xfff6 : IntLVD			*/	//жԴ:͵ѹLVD							
	IntWDT,					/* 0xfff8 : IntWDT			*/	//non-maskable жԴ:Źʱ		
	(void *)0xffff,			/* 0xfffa : Reserved		*/									
	IntSWI,					/* 0xfffc : IntSWI/INTUNDEF */	//non-maskable		
	STARTUP					/* 0xfffe : RESET			*/	//non-maskable			
};
#pragma section const
/* -------------------  SQ7613ж ---------------------- */

